package ch.std.messaging.rest;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jms.core.JmsTemplate;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import ch.std.messaging.beans.MessageBean;

@RestController
public class MessageController {

	private static Logger logger = LoggerFactory.getLogger(MessageController.class);

	@Autowired
	private JmsTemplate jmsTemplate;

	@GetMapping("/send")
	public MessageBean send(@RequestParam(value = "msg", required = false, defaultValue = "hello") String msg,
			@RequestParam(value = "to", required = false, defaultValue = "anonymous") String to) {
		logger.info("send to = " + to + " msg = " + msg);
		MessageBean messageBean = new MessageBean(to, msg); 
		jmsTemplate.convertAndSend("message", new MessageBean(to, msg));
		return messageBean;
	}
}
